/** \file src/xtal/xtal_thread.h
* \brief src/xtal/xtal_thread.h
*/

#ifndef XTAL_THREAD_H_INCLUDE_GUARD
#define XTAL_THREAD_H_INCLUDE_GUARD

#pragma once

namespace xtal{

class ThreadSpace;

/**
* \xbind
* \xinherit lib::builtin::Any
* \brief Xbh
*/
class Thread : public Base{
public:

	/**
	* \brief XbhIuWFNg𐶐
	*/
	Thread();

	~Thread();

public:

	/**
	* \brief XbhJn
	*/
	void start(const AnyPtr& callback);

	/**
	* \brief XbhI܂őҋ@
	*/
	void join();

public:

	/**
	* \brief Xbh؂ւ
	*/
	static void yield();
	
	/**
	* \brief JgXbhsecb点
	*/
	static void sleep(float_t sec);

public:

	void on_visit_members(Visitor& m);

protected:

	static void trampoline(void* data);

	void begin_thread();

protected:

	AnyPtr callback_;
	void* impl_;
	Environment* env_;
};

/**
* \xbind
* \xinherit lib::builtin::Any
* \brief ~[ebNX
*/
class Mutex : public Base{
public:

	/**
	* \brief ~[ebNXIuWFNg𐶐
	*/
	Mutex();

	~Mutex();

	/**
	* \brief bN
	*/
	void lock();

	/**
	* \brief AbN
	*/
	void unlock();

	void rawlock();

public:

	void* impl(){
		return impl_;
	}

private:
	void* impl_;
};

void yield_thread();
void sleep_thread(float_t sec);

}

#endif // XTAL_THREAD_H_INCLUDE_GUARD
